<?php
/*
 *      Patrick Bores - WebUserPrefs - SpamAssassin user_prefs file editor 
 *      Copyright (C) 2003  Patrick Bores
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License
 *      as published by the Free Software Foundation; either version 2
 *      of the License, or (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

	include("config.php");

	// If $usesssl is enabled, then check if the request is made with
	// HTTPS, SSL, on, and if not, redirect to the HTTPS server.

	if($usessl == 'yes' && !($HTTPS == 'On')) {
		//header("Location: https://$sitename$sitepath/index.php");
		header("Location: https://$_SERVER[SERVER_NAME]$_SERVER[REDIRECT_URL]");
		exit;
	}

	// Include functions
	include_once("functions.php");

	// Start loading files and setting up arrays.
	if($prefs_source == "db"){

		$connection = mysql_connect($db_host,$db_username,$db_password);
		if(!mysql_select_db($db_database))
			die("Could not connect to database: $db_database");

		$results = mysql_query("SELECT *
				FROM $db_table
				WHERE username='$db_sauser'
				ORDER BY prefid");

		for($i=0;$row = mysql_fetch_array($results);$i++){
			$user_prefs_array[$i] = "$row[preference] $row[value]";
		}
	}elseif($prefs_source == "file") {
		if(!(file_exists("$user_prefs"))){
			die("<b>Error!</b><br />Your settings file could not be found.");
			exit;
		}
	
		$user_prefs_array = file($user_prefs);
	}else{
		die("<b>Error!</b><br>You have not specified a valid preferences source.");
	}

	// If user_prefs_array is null, then initialize it with no data
	if(!is_array($user_prefs_array))
		$user_prefs_array = array();

	// Include all the panel files, and load
	// the user_prefs keys they want to use into an array.

	$panel_names = array();
	$prefs_keys = array();
	$dir_handle = @opendir($panels_dir) or die("Unable to open $panels_dir");

	while($file = readdir($dir_handle)){
		if(preg_match("/^[0-9]+_(.*)$/",$file)){
			array_push($panel_names,$file);
			include($panels_dir."/".$file);
		}
	}
	sort($panel_names,SORT_NUMERIC);
	for($i=0;$i<sizeof($panel_names);$i++){
		preg_match("/^[0-9]+_(.*)$/",$panel_names[$i],$match);
		$panel_names[$i] = $match[1];
		eval("\$prefs_keys = array_merge(\$prefs_keys,$match[1]_keys());");
	}
	closedir($dir_handle);
	$num_panels = sizeof($panel_names);

	// Perform actions now, if there were any.

	// Delete a rule
	if($_POST[delete] != ""){
		array_splice($user_prefs_array,$_POST[delete],1);
		if($prefs_source == "db") {
			mysql_query("DELETE FROM $db_table
					WHERE username='$db_sauser'
					AND preference='$_POST[preference]'
					AND value='$_POST[value]'");
		}
	}

	// Add a rule
	if($_POST[add] != ""){
		$address = $_POST[val];
		
		array_push($user_prefs_array,$_POST[key]." ".$address."\n");
		if($prefs_source == "db") {
			mysql_query("INSERT INTO $db_table(username,preference,value)
					VALUES('$db_sauser','$_POST[key]','$_POST[val]')");
		}
	}

	// Index $user_prefs_array
	$rules_keys = array("whitelist_from","whitelist_to","blacklist_from","whitelist_from_rcvd");
	$rules_array = array();
	$prefs_dir_array = array();

	while(list($key,$value) = each($user_prefs_array)){
		preg_match("/^([\S]+)[\s]+(.*)$/",$value,$matches);
		if(in_array($matches[1],$rules_keys)){
			$rules_array[$key] = $matches[0];
		}elseif(in_array($matches[1],$prefs_keys)){
			$prefs_dir_array[$matches[1]] = $key;
		}
	}

	// Handle Preferences Changes

	if($_POST[prefs] != ""){
		
		$prefs_change_array = array();

		for($i=0;$i<$num_panels;$i++){
			eval("$panel_names[$i]_apply();");
		}

		while(list($key,$value) = each($prefs_change_array)){
			$end_char = ($prefs_source == "db") ? "" : "\n";
			if(array_key_exists($key,$prefs_dir_array)){
				//$user_prefs_array[$prefs_dir_array[$key]] = $key." ".$value."\n";
				$user_prefs_array[$prefs_dir_array[$key]] = $key." ".$value.$end_char;
			}else{
				//array_push($user_prefs_array,$key." ".$value."\n");
				array_push($user_prefs_array,$key." ".$value.$end_char);
				$prefs_dir_array[$key] = (sizeof($user_prefs_array) - 1);
			}
		}

		$status_message = "Preferences have been updated.";
	}

	if($group_sort == "yes"){
		arsort($rules_array);
	}

	// Single call for sync if changes
	if($_POST[prefs] != "" || $_POST[add] != "" || $_POST[delete] != "")
		sync_user_prefs();

	//
	// Begin HTML Display
	//

	include("$header_file");

	// Display Preferences panels

	echo "<form action=\"$_SERVER[SCRIPT_NAME]\" method=\"POST\">";
	echo "<input type=\"hidden\" name=\"prefs\" value=\"1\" />";
	mesa_head($table_border_color,6,1,"100%");
	echo "<tr><td bgcolor=\"$table_titlebar_color\" colspan=\"2\" style=\"color: $text_titlebar_color;\">
		<b>Preferences</b></td></tr>";
	echo "<tr>";
	for($i=0;$i<$num_panels;$i++){

		$colspan = (!$row_end && ($i == ($num_panels - 1))) ? "2" : "1";

		echo "<td bgcolor=\"$table_background_color\" width=\"50%\" valign=\"top\" colspan=\"$colspan\">";
		eval($panel_names[$i]."_html();");
		echo "</td>";

		if($row_end && $i < ($num_panels - 1)){
			echo "</tr><tr>";
		}

		$row_end = !$row_end;
	}
	echo "</tr>";
	echo "<tr>
		<td colspan=\"2\" bgcolor=\"$table_background_color\">
			<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\">
				<tr>
					<td align=\"left\" style=\"color: red;\">$status_message</td>
					<td align=\"right\"><input type=\"submit\" value=\"Apply\" /></td>
				</tr>
			</table>
		</td>

		</tr>";

	mesa_tail();
	echo "</form>";

	// Add Rule Table

	echo "<form action=\"$_SERVER[SCRIPT_NAME]\" method=\"POST\">";
	echo "<input type=\"hidden\" name=\"add\" value=\"1\" />";
	mesa_head($table_border_color,6,1,"100%");
	echo "<tr><td bgcolor=\"$table_titlebar_color\" colspan=\"3\" style=\"color: $text_titlebar_color;\"><b>Add Rule</b></td></tr>
	<tr><td bgcolor=\"$table_background_color\" colspan=\"3\">
		Add your own custom filter rules here. Here's how:<br />
		<ol>
		<li>Choose an action from the menu on the left.</li>
		<li>Type the e-mail address or pattern into the field on the right.</li>
		<li>Click on the \"Add Rule\" button.</li>
		</ol>
		An asterick (*) can be used as a \"wild card\" for greater flexibility. For example:<br />
		<ul>
		<li>*@spamisp.com applies to every address at the domain \"spamisp.com\"</li>
		<li>*@*.spamisp.com applies to every address at any sub-domain of \"spamisp.com\"</li>
		</ul>
	</td></tr>
	<tr>
		<td bgcolor=\"$table_background_color\">
			<select name=\"key\">
				<option value=\"whitelist_from\">Accept Mail From</option>
				<option value=\"blacklist_from\">Reject Mail From</option>
				<option value=\"whitelist_to\">Accept Mail Sent To</option>
			</select>
		</td>
		<td bgcolor=\"$table_background_color\">
		<input type=\"text\" name=\"val\" />
		</td>
		<td bgcolor=\"$table_background_color\" align=\"center\">
			<input type=\"submit\" value=\"Add Rule\" />
		</td>
	</tr>";

	mesa_tail();
	echo "</form>";

	mesa_head($table_border_color,6,1,"100%");
		echo "<tr><td bgcolor=\"$table_titlebar_color\" colspan=\"3\" style=\"color: $text_titlebar_color;\"><b>Current Rules</b></td></tr>";

		$row_toggle = 0;

		while(list($line_num,$rule) = each($rules_array)){

			preg_match("/^([\S]+)[\s]+(.*)$/",$rule,$matches);

			$key = $matches[1];
			$val = $matches[2];

			$current_row_color = ($row_toggle == 1) ? $table_alt_row_color : $table_background_color;
			$row_toggle = 1 - $row_toggle;

			echo "<tr>";
			echo "<td bgcolor=\"$current_row_color\">";
				switch($key){
					case "whitelist_from":
						echo "<font color=\"007700\">Accept</font> Mail From";
						break;
					case "whitelist_from_rcvd":
						echo "<font color=\"007700\">Accept</font> Mail From (network)";
						break;
					case "whitelist_to":
						echo "<font color=\"007700\">Accept</font> Mail Sent To";
						break;
					case "blacklist_from":
						echo "<font color=\"FF0000\">Reject</font> Mail From";
						break;
				}
			echo "</td>";

			echo "<td bgcolor=\"$current_row_color\">$val</td>
			<td bgcolor=\"$current_row_color\" align=\"center\">
				<form action=\"$_SERVER[SCRIPT_NAME]\" method=\"POST\">
				<input type=\"hidden\" name=\"delete\" value=\"$line_num\" />
				<input type=\"hidden\" name=\"preference\" value=\"$key\" />
				<input type=\"hidden\" name=\"value\" value=\"$val\" />
				<input type=\"submit\" value=\"Delete Rule\" /></form></td></tr>";
			
		}

	mesa_tail();

	include("$footer_file");
?>
